﻿Type=StaticCode
Version=3.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Private Sub Process_Globals
	Private fx As JFX	
End Sub

'Given two infinite lines extrapolated from the segments AB and CD, 
'this function will return the intersection result code and x,y coordinate.
'Return format: {resultCode, x, y}
'Error codes:
'0 - Single Point Intersection
'1 - Parallel lines
'2 - Coincident lines
Sub LineIntersector(Ax As Double, Ay As Double, Bx As Double, By As Double, Cx As Double, Cy As Double, Dx As Double, Dy As Double) As Object
	Dim divisor   = ((Ax-Bx)*(Cy-Dy)-(Ay-By)*(Cx-Dx)) As Double
	If  divisor   = 0 Then Return Array As Double(1, 0, 0)
	Dim dividendX = ((Ax*By-Ay*Bx)*(Cx-Dx)-(Ax-Bx)*(Cx*Dy-Cy*Dx)) As Double
	Dim dividendY = ((Ax*By-Ay*Bx)*(Cy-Dy)-(Ay-By)*(Cx*Dy-Cy*Dx)) As Double
	If  dividendX = 0 Or dividendY = 0 Then Return Array As Double(2, 0, 0)
	Return Array As Double(0, dividendX / divisor, dividendY / divisor)
End Sub
#region Original Function
'	Return Array As Double( _	
'	((Ax*By-Ay*Bx)*(Cx-Dx)-(Ax-Bx)*(Cx*Dy-Cy*Dx)) / _
'	((Ax-Bx)*(Cy-Dy)-(Ay-By)*(Cx-Dx)), _	
'	((Ax*By-Ay*Bx)*(Cy-Dy)-(Ay-By)*(Cx*Dy-Cy*Dx)) / _
'	((Ax-Bx)*(Cy-Dy)-(Ay-By)*(Cx-Dx)))
#end region


'Given two vectors U and V, this function returns its intersection point
Sub VectorIntersector(Ux As Double, Uy As Double, Uangle As Double,Usize As Double, Vx As Double, Vy As Double, Vangle As Double, Vsize As Double, Radians As Boolean) As Object
	If Radians Then 		
		Uangle = Uangle * 180 / cPI
		Vangle = Vangle * 180 / cPI
	End If	
	Return Array As Double( _	
	((Ux*SinD(Uangle)*Usize-Uy*CosD(Uangle)*Usize)*(Vx-CosD(Vangle)*Vsize)-(Ux-CosD(Uangle)*Usize)*(Vx*SinD(Vangle)*Vsize-Vy*CosD(Vangle)*Vsize)) / _
	((Ux-CosD(Uangle)*Usize)*(Vy-SinD(Vangle)*Vsize)-(Uy-SinD(Uangle)*Usize)*(Vx-CosD(Vangle)*Vsize)), _	
	((Ux*SinD(Uangle)*Usize-Uy*CosD(Uangle)*Usize)*(Vy-SinD(Vangle)*Vsize)-(Uy-SinD(Uangle)*Usize)*(Vx*SinD(Vangle)*Vsize-Vy*CosD(Vangle)*Vsize)) / _
	((Ux-CosD(Uangle)*Usize)*(Vy-SinD(Vangle)*Vsize)-(Uy-SinD(Uangle)*Usize)*(Vx-CosD(Vangle)*Vsize)))
End Sub